/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_AUDIO)

#include "JSAudioWorkletGlobalScope.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "JSAudioWorkletProcessorConstructor.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertCallbacks.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSMessageEvent.h"
#include "JSMessagePort.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>

#if ENABLE(WEB_AUDIO)
#include "JSAudioWorkletGlobalScope.h"
#include "JSAudioWorkletProcessor.h"
#endif


namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsAudioWorkletGlobalScopeInstanceFunction_registerProcessor);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsAudioWorkletGlobalScopeConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_currentFrame);
static JSC_DECLARE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_currentTime);
static JSC_DECLARE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_sampleRate);
#if ENABLE(WEB_AUDIO)
static JSC_DECLARE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_AudioWorkletGlobalScopeConstructor);
static JSC_DECLARE_CUSTOM_SETTER(setJSAudioWorkletGlobalScope_AudioWorkletGlobalScopeConstructor);
#endif
#if ENABLE(WEB_AUDIO)
static JSC_DECLARE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_AudioWorkletProcessorConstructor);
static JSC_DECLARE_CUSTOM_SETTER(setJSAudioWorkletGlobalScope_AudioWorkletProcessorConstructor);
#endif
static JSC_DECLARE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_MessageEventConstructor);
static JSC_DECLARE_CUSTOM_SETTER(setJSAudioWorkletGlobalScope_MessageEventConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_MessagePortConstructor);
static JSC_DECLARE_CUSTOM_SETTER(setJSAudioWorkletGlobalScope_MessagePortConstructor);

using JSAudioWorkletGlobalScopeDOMConstructor = JSDOMConstructorNotConstructable<JSAudioWorkletGlobalScope>;

/* Hash table */

static const struct CompactHashIndex JSAudioWorkletGlobalScopeTableIndex[16] = {
    { 2, -1 },
    { -1, -1 },
    { 1, -1 },
    { -1, -1 },
    { 0, -1 },
    { 4, -1 },
    { -1, -1 },
    { 7, -1 },
    { 6, -1 },
    { 3, -1 },
    { -1, -1 },
    { -1, -1 },
    { 5, -1 },
    { -1, -1 },
    { -1, -1 },
    { -1, -1 },
};


static const HashTableValue JSAudioWorkletGlobalScopeTableValues[] =
{
    { "currentFrame", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAudioWorkletGlobalScope_currentFrame), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "currentTime", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAudioWorkletGlobalScope_currentTime), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "sampleRate", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAudioWorkletGlobalScope_sampleRate), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
#if ENABLE(WEB_AUDIO)
    { "AudioWorkletGlobalScope", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAudioWorkletGlobalScope_AudioWorkletGlobalScopeConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAudioWorkletGlobalScope_AudioWorkletGlobalScopeConstructor) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(WEB_AUDIO)
    { "AudioWorkletProcessor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAudioWorkletGlobalScope_AudioWorkletProcessorConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAudioWorkletGlobalScope_AudioWorkletProcessorConstructor) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
    { "MessageEvent", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAudioWorkletGlobalScope_MessageEventConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAudioWorkletGlobalScope_MessageEventConstructor) } },
    { "MessagePort", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAudioWorkletGlobalScope_MessagePortConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAudioWorkletGlobalScope_MessagePortConstructor) } },
    { "registerProcessor", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsAudioWorkletGlobalScopeInstanceFunction_registerProcessor), (intptr_t) (2) } },
};

static const HashTable JSAudioWorkletGlobalScopeTable = { 8, 15, true, JSAudioWorkletGlobalScope::info(), JSAudioWorkletGlobalScopeTableValues, JSAudioWorkletGlobalScopeTableIndex };
template<> JSValue JSAudioWorkletGlobalScopeDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSWorkletGlobalScope::getConstructor(vm, &globalObject);
}

template<> void JSAudioWorkletGlobalScopeDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, globalObject.getPrototypeDirect(vm), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(vm, "AudioWorkletGlobalScope"_s), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSAudioWorkletGlobalScopeDOMConstructor::s_info = { "AudioWorkletGlobalScope", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAudioWorkletGlobalScopeDOMConstructor) };

/* Hash table for prototype */

static const struct CompactHashIndex JSAudioWorkletGlobalScopePrototypeTableIndex[2] = {
    { -1, -1 },
    { 0, -1 },
};


static const HashTableValue JSAudioWorkletGlobalScopePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAudioWorkletGlobalScopeConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

static const HashTable JSAudioWorkletGlobalScopePrototypeTable = { 1, 1, true, JSAudioWorkletGlobalScope::info(), JSAudioWorkletGlobalScopePrototypeTableValues, JSAudioWorkletGlobalScopePrototypeTableIndex };
const ClassInfo JSAudioWorkletGlobalScopePrototype::s_info = { "AudioWorkletGlobalScope", &Base::s_info, &JSAudioWorkletGlobalScopePrototypeTable, nullptr, CREATE_METHOD_TABLE(JSAudioWorkletGlobalScopePrototype) };

void JSAudioWorkletGlobalScopePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSAudioWorkletGlobalScope::s_info = { "AudioWorkletGlobalScope", &Base::s_info, &JSAudioWorkletGlobalScopeTable, nullptr, CREATE_METHOD_TABLE(JSAudioWorkletGlobalScope) };

JSAudioWorkletGlobalScope::JSAudioWorkletGlobalScope(VM& vm, Structure* structure, Ref<AudioWorkletGlobalScope>&& impl)
    : JSWorkletGlobalScope(vm, structure, WTFMove(impl))
{
}

void JSAudioWorkletGlobalScope::finishCreation(VM& vm, JSProxy* proxy)
{
    Base::finishCreation(vm, proxy);

    static_assert(!std::is_base_of<ActiveDOMObject, AudioWorkletGlobalScope>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSValue JSAudioWorkletGlobalScope::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSAudioWorkletGlobalScopeDOMConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSAudioWorkletGlobalScope* IDLAttribute<JSAudioWorkletGlobalScope>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto decodedThisValue = JSValue::decode(thisValue);
    if (decodedThisValue.isUndefinedOrNull())
        decodedThisValue = JSValue(&lexicalGlobalObject).toThis(&lexicalGlobalObject, ECMAMode::sloppy());
    return jsDynamicCast<JSAudioWorkletGlobalScope*>(vm, decodedThisValue);
}

template<> inline JSAudioWorkletGlobalScope* IDLOperation<JSAudioWorkletGlobalScope>::cast(JSGlobalObject& lexicalGlobalObject, CallFrame& callFrame)
{
    return jsDynamicCast<JSAudioWorkletGlobalScope*>(JSC::getVM(&lexicalGlobalObject), callFrame.thisValue());
}

JSC_DEFINE_CUSTOM_GETTER(jsAudioWorkletGlobalScopeConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSAudioWorkletGlobalScopePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSAudioWorkletGlobalScope::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSValue jsAudioWorkletGlobalScope_currentFrameGetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedLongLong>(lexicalGlobalObject, throwScope, impl.currentFrame())));
}

JSC_DEFINE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_currentFrame, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::get<jsAudioWorkletGlobalScope_currentFrameGetter>(*lexicalGlobalObject, thisValue, "currentFrame");
}

static inline JSValue jsAudioWorkletGlobalScope_currentTimeGetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.currentTime())));
}

JSC_DEFINE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_currentTime, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::get<jsAudioWorkletGlobalScope_currentTimeGetter>(*lexicalGlobalObject, thisValue, "currentTime");
}

static inline JSValue jsAudioWorkletGlobalScope_sampleRateGetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLFloat>(lexicalGlobalObject, throwScope, impl.sampleRate())));
}

JSC_DEFINE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_sampleRate, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::get<jsAudioWorkletGlobalScope_sampleRateGetter>(*lexicalGlobalObject, thisValue, "sampleRate");
}

#if ENABLE(WEB_AUDIO)
static inline JSValue jsAudioWorkletGlobalScope_AudioWorkletGlobalScopeConstructorGetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return JSAudioWorkletGlobalScope::getConstructor(JSC::getVM(&lexicalGlobalObject), thisObject.globalObject());
}

JSC_DEFINE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_AudioWorkletGlobalScopeConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::get<jsAudioWorkletGlobalScope_AudioWorkletGlobalScopeConstructorGetter>(*lexicalGlobalObject, thisValue, "AudioWorkletGlobalScope");
}

#endif

#if ENABLE(WEB_AUDIO)
static inline bool setJSAudioWorkletGlobalScope_AudioWorkletGlobalScopeConstructorSetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    // Shadowing a built-in constructor.
    return thisObject.putDirect(vm, Identifier::fromString(vm, reinterpret_cast<const LChar*>("AudioWorkletGlobalScope"), strlen("AudioWorkletGlobalScope")), value);
}

JSC_DEFINE_CUSTOM_SETTER(setJSAudioWorkletGlobalScope_AudioWorkletGlobalScopeConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::set<setJSAudioWorkletGlobalScope_AudioWorkletGlobalScopeConstructorSetter>(*lexicalGlobalObject, thisValue, encodedValue, "AudioWorkletGlobalScope");
}

#endif

#if ENABLE(WEB_AUDIO)
static inline JSValue jsAudioWorkletGlobalScope_AudioWorkletProcessorConstructorGetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return JSAudioWorkletProcessor::getConstructor(JSC::getVM(&lexicalGlobalObject), thisObject.globalObject());
}

JSC_DEFINE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_AudioWorkletProcessorConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::get<jsAudioWorkletGlobalScope_AudioWorkletProcessorConstructorGetter>(*lexicalGlobalObject, thisValue, "AudioWorkletProcessor");
}

#endif

#if ENABLE(WEB_AUDIO)
static inline bool setJSAudioWorkletGlobalScope_AudioWorkletProcessorConstructorSetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    // Shadowing a built-in constructor.
    return thisObject.putDirect(vm, Identifier::fromString(vm, reinterpret_cast<const LChar*>("AudioWorkletProcessor"), strlen("AudioWorkletProcessor")), value);
}

JSC_DEFINE_CUSTOM_SETTER(setJSAudioWorkletGlobalScope_AudioWorkletProcessorConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::set<setJSAudioWorkletGlobalScope_AudioWorkletProcessorConstructorSetter>(*lexicalGlobalObject, thisValue, encodedValue, "AudioWorkletProcessor");
}

#endif

static inline JSValue jsAudioWorkletGlobalScope_MessageEventConstructorGetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return JSMessageEvent::getConstructor(JSC::getVM(&lexicalGlobalObject), thisObject.globalObject());
}

JSC_DEFINE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_MessageEventConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::get<jsAudioWorkletGlobalScope_MessageEventConstructorGetter>(*lexicalGlobalObject, thisValue, "MessageEvent");
}

static inline bool setJSAudioWorkletGlobalScope_MessageEventConstructorSetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    // Shadowing a built-in constructor.
    return thisObject.putDirect(vm, Identifier::fromString(vm, reinterpret_cast<const LChar*>("MessageEvent"), strlen("MessageEvent")), value);
}

JSC_DEFINE_CUSTOM_SETTER(setJSAudioWorkletGlobalScope_MessageEventConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::set<setJSAudioWorkletGlobalScope_MessageEventConstructorSetter>(*lexicalGlobalObject, thisValue, encodedValue, "MessageEvent");
}

static inline JSValue jsAudioWorkletGlobalScope_MessagePortConstructorGetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return JSMessagePort::getConstructor(JSC::getVM(&lexicalGlobalObject), thisObject.globalObject());
}

JSC_DEFINE_CUSTOM_GETTER(jsAudioWorkletGlobalScope_MessagePortConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::get<jsAudioWorkletGlobalScope_MessagePortConstructorGetter>(*lexicalGlobalObject, thisValue, "MessagePort");
}

static inline bool setJSAudioWorkletGlobalScope_MessagePortConstructorSetter(JSGlobalObject& lexicalGlobalObject, JSAudioWorkletGlobalScope& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    // Shadowing a built-in constructor.
    return thisObject.putDirect(vm, Identifier::fromString(vm, reinterpret_cast<const LChar*>("MessagePort"), strlen("MessagePort")), value);
}

JSC_DEFINE_CUSTOM_SETTER(setJSAudioWorkletGlobalScope_MessagePortConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSAudioWorkletGlobalScope>::set<setJSAudioWorkletGlobalScope_MessagePortConstructorSetter>(*lexicalGlobalObject, thisValue, encodedValue, "MessagePort");
}

static inline JSC::EncodedJSValue jsAudioWorkletGlobalScopeInstanceFunction_registerProcessorBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSAudioWorkletGlobalScope>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 2))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto name = convert<IDLDOMString>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto processorCtor = convert<IDLCallbackFunction<JSAudioWorkletProcessorConstructor>>(*lexicalGlobalObject, argument1.value(), *castedThis->globalObject(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentMustBeFunctionError(lexicalGlobalObject, scope, 1, "processorCtor", "AudioWorkletGlobalScope", "registerProcessor"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    throwScope.release();
    propagateException(*lexicalGlobalObject, throwScope, impl.registerProcessor(WTFMove(name), processorCtor.releaseNonNull()));
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsAudioWorkletGlobalScopeInstanceFunction_registerProcessor, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSAudioWorkletGlobalScope>::call<jsAudioWorkletGlobalScopeInstanceFunction_registerProcessorBody>(*lexicalGlobalObject, *callFrame, "registerProcessor");
}

JSC::IsoSubspace* JSAudioWorkletGlobalScope::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForAudioWorkletGlobalScope.get())
        return space;
    spaces.m_subspaceForAudioWorkletGlobalScope = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, clientData.m_heapCellTypeForJSAudioWorkletGlobalScope.get(), JSAudioWorkletGlobalScope);
    auto* space = spaces.m_subspaceForAudioWorkletGlobalScope.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    if (&JSAudioWorkletGlobalScope::visitOutputConstraints != &JSC::JSCell::visitOutputConstraints)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSAudioWorkletGlobalScope::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSAudioWorkletGlobalScope*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

AudioWorkletGlobalScope* JSAudioWorkletGlobalScope::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSAudioWorkletGlobalScope*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(WEB_AUDIO)
