/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_AUDIO)

#include "JSPannerNode.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "JSAudioParam.h"
#include "JSBaseAudioContext.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSDistanceModelType.h"
#include "JSPannerOptions.h"
#include "JSPanningModelType.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsPannerNodePrototypeFunction_setPosition);
static JSC_DECLARE_HOST_FUNCTION(jsPannerNodePrototypeFunction_setOrientation);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsPannerNodeConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_panningModel);
static JSC_DECLARE_CUSTOM_SETTER(setJSPannerNode_panningModel);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_distanceModel);
static JSC_DECLARE_CUSTOM_SETTER(setJSPannerNode_distanceModel);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_refDistance);
static JSC_DECLARE_CUSTOM_SETTER(setJSPannerNode_refDistance);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_maxDistance);
static JSC_DECLARE_CUSTOM_SETTER(setJSPannerNode_maxDistance);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_rolloffFactor);
static JSC_DECLARE_CUSTOM_SETTER(setJSPannerNode_rolloffFactor);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_coneInnerAngle);
static JSC_DECLARE_CUSTOM_SETTER(setJSPannerNode_coneInnerAngle);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_coneOuterAngle);
static JSC_DECLARE_CUSTOM_SETTER(setJSPannerNode_coneOuterAngle);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_coneOuterGain);
static JSC_DECLARE_CUSTOM_SETTER(setJSPannerNode_coneOuterGain);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_positionX);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_positionY);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_positionZ);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_orientationX);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_orientationY);
static JSC_DECLARE_CUSTOM_GETTER(jsPannerNode_orientationZ);

class JSPannerNodePrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSPannerNodePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSPannerNodePrototype* ptr = new (NotNull, JSC::allocateCell<JSPannerNodePrototype>(vm.heap)) JSPannerNodePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSPannerNodePrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSPannerNodePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSPannerNodePrototype, JSPannerNodePrototype::Base);

using JSPannerNodeDOMConstructor = JSDOMConstructor<JSPannerNode>;

template<> EncodedJSValue JSC_HOST_CALL_ATTRIBUTES JSPannerNodeDOMConstructor::construct(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    VM& vm = lexicalGlobalObject->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* castedThis = jsCast<JSPannerNodeDOMConstructor*>(callFrame->jsCallee());
    ASSERT(castedThis);
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto context = convert<IDLInterface<BaseAudioContext>>(*lexicalGlobalObject, argument0.value(), [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwArgumentTypeError(lexicalGlobalObject, scope, 0, "context", "PannerNode", nullptr, "BaseAudioContext"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->argument(1);
    auto options = convert<IDLDictionary<PannerOptions>>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = PannerNode::create(*context, WTFMove(options));
    static_assert(TypeOrExceptionOrUnderlyingType<decltype(object)>::isRef);
    auto jsValue = toJSNewlyCreated<IDLInterface<PannerNode>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, WTFMove(object));
    if constexpr (IsExceptionOr<decltype(object)>)
        RETURN_IF_EXCEPTION(throwScope, { });
    setSubclassStructureIfNeeded<PannerNode>(lexicalGlobalObject, callFrame, asObject(jsValue));
    RETURN_IF_EXCEPTION(throwScope, { });
    return JSValue::encode(jsValue);
}
JSC_ANNOTATE_HOST_FUNCTION(JSPannerNodeDOMConstructorConstruct, JSPannerNodeDOMConstructor::construct);

template<> JSValue JSPannerNodeDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSAudioNode::getConstructor(vm, &globalObject);
}

template<> void JSPannerNodeDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSPannerNode::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(vm, "PannerNode"_s), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSPannerNodeDOMConstructor::s_info = { "PannerNode", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPannerNodeDOMConstructor) };

/* Hash table for prototype */

static const HashTableValue JSPannerNodePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNodeConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "panningModel", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_panningModel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPannerNode_panningModel) } },
    { "distanceModel", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_distanceModel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPannerNode_distanceModel) } },
    { "refDistance", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_refDistance), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPannerNode_refDistance) } },
    { "maxDistance", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_maxDistance), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPannerNode_maxDistance) } },
    { "rolloffFactor", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_rolloffFactor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPannerNode_rolloffFactor) } },
    { "coneInnerAngle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_coneInnerAngle), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPannerNode_coneInnerAngle) } },
    { "coneOuterAngle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_coneOuterAngle), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPannerNode_coneOuterAngle) } },
    { "coneOuterGain", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_coneOuterGain), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPannerNode_coneOuterGain) } },
    { "positionX", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_positionX), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "positionY", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_positionY), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "positionZ", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_positionZ), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "orientationX", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_orientationX), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "orientationY", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_orientationY), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "orientationZ", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPannerNode_orientationZ), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "setPosition", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsPannerNodePrototypeFunction_setPosition), (intptr_t) (3) } },
    { "setOrientation", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsPannerNodePrototypeFunction_setOrientation), (intptr_t) (3) } },
};

const ClassInfo JSPannerNodePrototype::s_info = { "PannerNode", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPannerNodePrototype) };

void JSPannerNodePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSPannerNode::info(), JSPannerNodePrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSPannerNode::s_info = { "PannerNode", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPannerNode) };

JSPannerNode::JSPannerNode(Structure* structure, JSDOMGlobalObject& globalObject, Ref<PannerNode>&& impl)
    : JSAudioNode(structure, globalObject, WTFMove(impl))
{
}

void JSPannerNode::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, PannerNode>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSPannerNode::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSPannerNodePrototype::create(vm, &globalObject, JSPannerNodePrototype::createStructure(vm, &globalObject, JSAudioNode::prototype(vm, globalObject)));
}

JSObject* JSPannerNode::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSPannerNode>(vm, globalObject);
}

JSValue JSPannerNode::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSPannerNodeDOMConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSPannerNode* IDLAttribute<JSPannerNode>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSPannerNode*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

template<> inline JSPannerNode* IDLOperation<JSPannerNode>::cast(JSGlobalObject& lexicalGlobalObject, CallFrame& callFrame)
{
    return jsDynamicCast<JSPannerNode*>(JSC::getVM(&lexicalGlobalObject), callFrame.thisValue());
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNodeConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSPannerNodePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSPannerNode::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSValue jsPannerNode_panningModelGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLEnumeration<PanningModelType>>(lexicalGlobalObject, throwScope, impl.panningModel())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_panningModel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_panningModelGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "panningModel");
}

static inline bool setJSPannerNode_panningModelSetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto optionalNativeValue = parseEnumeration<PanningModelType>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    if (UNLIKELY(!optionalNativeValue))
        return false;
    auto nativeValue = optionalNativeValue.value();
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setPanningModel(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSPannerNode_panningModel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSPannerNode>::set<setJSPannerNode_panningModelSetter>(*lexicalGlobalObject, thisValue, encodedValue, "panningModel");
}

static inline JSValue jsPannerNode_distanceModelGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLEnumeration<DistanceModelType>>(lexicalGlobalObject, throwScope, impl.distanceModel())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_distanceModel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_distanceModelGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "distanceModel");
}

static inline bool setJSPannerNode_distanceModelSetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto optionalNativeValue = parseEnumeration<DistanceModelType>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    if (UNLIKELY(!optionalNativeValue))
        return false;
    auto nativeValue = optionalNativeValue.value();
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setDistanceModel(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSPannerNode_distanceModel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSPannerNode>::set<setJSPannerNode_distanceModelSetter>(*lexicalGlobalObject, thisValue, encodedValue, "distanceModel");
}

static inline JSValue jsPannerNode_refDistanceGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.refDistance())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_refDistance, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_refDistanceGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "refDistance");
}

static inline bool setJSPannerNode_refDistanceSetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setRefDistance(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSPannerNode_refDistance, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSPannerNode>::set<setJSPannerNode_refDistanceSetter>(*lexicalGlobalObject, thisValue, encodedValue, "refDistance");
}

static inline JSValue jsPannerNode_maxDistanceGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.maxDistance())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_maxDistance, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_maxDistanceGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "maxDistance");
}

static inline bool setJSPannerNode_maxDistanceSetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setMaxDistance(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSPannerNode_maxDistance, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSPannerNode>::set<setJSPannerNode_maxDistanceSetter>(*lexicalGlobalObject, thisValue, encodedValue, "maxDistance");
}

static inline JSValue jsPannerNode_rolloffFactorGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.rolloffFactor())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_rolloffFactor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_rolloffFactorGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "rolloffFactor");
}

static inline bool setJSPannerNode_rolloffFactorSetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setRolloffFactor(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSPannerNode_rolloffFactor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSPannerNode>::set<setJSPannerNode_rolloffFactorSetter>(*lexicalGlobalObject, thisValue, encodedValue, "rolloffFactor");
}

static inline JSValue jsPannerNode_coneInnerAngleGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.coneInnerAngle())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_coneInnerAngle, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_coneInnerAngleGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "coneInnerAngle");
}

static inline bool setJSPannerNode_coneInnerAngleSetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setConeInnerAngle(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSPannerNode_coneInnerAngle, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSPannerNode>::set<setJSPannerNode_coneInnerAngleSetter>(*lexicalGlobalObject, thisValue, encodedValue, "coneInnerAngle");
}

static inline JSValue jsPannerNode_coneOuterAngleGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.coneOuterAngle())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_coneOuterAngle, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_coneOuterAngleGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "coneOuterAngle");
}

static inline bool setJSPannerNode_coneOuterAngleSetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setConeOuterAngle(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSPannerNode_coneOuterAngle, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSPannerNode>::set<setJSPannerNode_coneOuterAngleSetter>(*lexicalGlobalObject, thisValue, encodedValue, "coneOuterAngle");
}

static inline JSValue jsPannerNode_coneOuterGainGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.coneOuterGain())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_coneOuterGain, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_coneOuterGainGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "coneOuterGain");
}

static inline bool setJSPannerNode_coneOuterGainSetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setConeOuterGain(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSPannerNode_coneOuterGain, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSPannerNode>::set<setJSPannerNode_coneOuterGainSetter>(*lexicalGlobalObject, thisValue, encodedValue, "coneOuterGain");
}

static inline JSValue jsPannerNode_positionXGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.positionX())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_positionX, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_positionXGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "positionX");
}

static inline JSValue jsPannerNode_positionYGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.positionY())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_positionY, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_positionYGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "positionY");
}

static inline JSValue jsPannerNode_positionZGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.positionZ())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_positionZ, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_positionZGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "positionZ");
}

static inline JSValue jsPannerNode_orientationXGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.orientationX())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_orientationX, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_orientationXGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "orientationX");
}

static inline JSValue jsPannerNode_orientationYGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.orientationY())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_orientationY, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_orientationYGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "orientationY");
}

static inline JSValue jsPannerNode_orientationZGetter(JSGlobalObject& lexicalGlobalObject, JSPannerNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.orientationZ())));
}

JSC_DEFINE_CUSTOM_GETTER(jsPannerNode_orientationZ, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSPannerNode>::get<jsPannerNode_orientationZGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "orientationZ");
}

static inline JSC::EncodedJSValue jsPannerNodePrototypeFunction_setPositionBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSPannerNode>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 3))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto x = convert<IDLFloat>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto y = convert<IDLFloat>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->uncheckedArgument(2);
    auto z = convert<IDLFloat>(*lexicalGlobalObject, argument2.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    throwScope.release();
    propagateException(*lexicalGlobalObject, throwScope, impl.setPosition(WTFMove(x), WTFMove(y), WTFMove(z)));
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsPannerNodePrototypeFunction_setPosition, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSPannerNode>::call<jsPannerNodePrototypeFunction_setPositionBody>(*lexicalGlobalObject, *callFrame, "setPosition");
}

static inline JSC::EncodedJSValue jsPannerNodePrototypeFunction_setOrientationBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSPannerNode>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 3))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto x = convert<IDLFloat>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->uncheckedArgument(1);
    auto y = convert<IDLFloat>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->uncheckedArgument(2);
    auto z = convert<IDLFloat>(*lexicalGlobalObject, argument2.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    throwScope.release();
    propagateException(*lexicalGlobalObject, throwScope, impl.setOrientation(WTFMove(x), WTFMove(y), WTFMove(z)));
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsPannerNodePrototypeFunction_setOrientation, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSPannerNode>::call<jsPannerNodePrototypeFunction_setOrientationBody>(*lexicalGlobalObject, *callFrame, "setOrientation");
}

JSC::IsoSubspace* JSPannerNode::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForPannerNode.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSPannerNode> || !JSPannerNode::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSPannerNode>)
        spaces.m_subspaceForPannerNode = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.destructibleObjectHeapCellType.get(), JSPannerNode);
    else
        spaces.m_subspaceForPannerNode = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.cellHeapCellType.get(), JSPannerNode);
    auto* space = spaces.m_subspaceForPannerNode.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    if (&JSPannerNode::visitOutputConstraints != &JSC::JSCell::visitOutputConstraints)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSPannerNode::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSPannerNode*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7PannerNode@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore10PannerNodeE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<PannerNode>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    const void* actualVTablePointer = getVTablePointer(impl.ptr());
#if PLATFORM(WIN)
    void* expectedVTablePointer = __identifier("??_7PannerNode@WebCore@@6B@");
#else
    void* expectedVTablePointer = &_ZTVN7WebCore10PannerNodeE[2];
#endif

    // If this fails PannerNode does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<PannerNode>::value, "PannerNode is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // PannerNode has subclasses. If PannerNode has subclasses that get passed
    // to toJS() we currently require PannerNode you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<PannerNode>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, PannerNode& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}


}

#endif // ENABLE(WEB_AUDIO)
