/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSSpeechRecognitionAlternative.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsSpeechRecognitionAlternativeConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsSpeechRecognitionAlternative_transcript);
static JSC_DECLARE_CUSTOM_GETTER(jsSpeechRecognitionAlternative_confidence);

class JSSpeechRecognitionAlternativePrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSSpeechRecognitionAlternativePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSSpeechRecognitionAlternativePrototype* ptr = new (NotNull, JSC::allocateCell<JSSpeechRecognitionAlternativePrototype>(vm.heap)) JSSpeechRecognitionAlternativePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSSpeechRecognitionAlternativePrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSSpeechRecognitionAlternativePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSSpeechRecognitionAlternativePrototype, JSSpeechRecognitionAlternativePrototype::Base);

using JSSpeechRecognitionAlternativeDOMConstructor = JSDOMConstructorNotConstructable<JSSpeechRecognitionAlternative>;

template<> JSValue JSSpeechRecognitionAlternativeDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSSpeechRecognitionAlternativeDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSSpeechRecognitionAlternative::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(vm, "SpeechRecognitionAlternative"_s), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSSpeechRecognitionAlternativeDOMConstructor::s_info = { "SpeechRecognitionAlternative", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSSpeechRecognitionAlternativeDOMConstructor) };

/* Hash table for prototype */

static const HashTableValue JSSpeechRecognitionAlternativePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSpeechRecognitionAlternativeConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "transcript", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSpeechRecognitionAlternative_transcript), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "confidence", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSpeechRecognitionAlternative_confidence), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSSpeechRecognitionAlternativePrototype::s_info = { "SpeechRecognitionAlternative", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSSpeechRecognitionAlternativePrototype) };

void JSSpeechRecognitionAlternativePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSSpeechRecognitionAlternative::info(), JSSpeechRecognitionAlternativePrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSSpeechRecognitionAlternative::s_info = { "SpeechRecognitionAlternative", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSSpeechRecognitionAlternative) };

JSSpeechRecognitionAlternative::JSSpeechRecognitionAlternative(Structure* structure, JSDOMGlobalObject& globalObject, Ref<SpeechRecognitionAlternative>&& impl)
    : JSDOMWrapper<SpeechRecognitionAlternative>(structure, globalObject, WTFMove(impl))
{
}

void JSSpeechRecognitionAlternative::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, SpeechRecognitionAlternative>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSSpeechRecognitionAlternative::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSSpeechRecognitionAlternativePrototype::create(vm, &globalObject, JSSpeechRecognitionAlternativePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSSpeechRecognitionAlternative::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSSpeechRecognitionAlternative>(vm, globalObject);
}

JSValue JSSpeechRecognitionAlternative::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSSpeechRecognitionAlternativeDOMConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSSpeechRecognitionAlternative::destroy(JSC::JSCell* cell)
{
    JSSpeechRecognitionAlternative* thisObject = static_cast<JSSpeechRecognitionAlternative*>(cell);
    thisObject->JSSpeechRecognitionAlternative::~JSSpeechRecognitionAlternative();
}

template<> inline JSSpeechRecognitionAlternative* IDLAttribute<JSSpeechRecognitionAlternative>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSSpeechRecognitionAlternative*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

JSC_DEFINE_CUSTOM_GETTER(jsSpeechRecognitionAlternativeConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSSpeechRecognitionAlternativePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSSpeechRecognitionAlternative::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSValue jsSpeechRecognitionAlternative_transcriptGetter(JSGlobalObject& lexicalGlobalObject, JSSpeechRecognitionAlternative& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDOMString>(lexicalGlobalObject, throwScope, impl.transcript())));
}

JSC_DEFINE_CUSTOM_GETTER(jsSpeechRecognitionAlternative_transcript, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSSpeechRecognitionAlternative>::get<jsSpeechRecognitionAlternative_transcriptGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "transcript");
}

static inline JSValue jsSpeechRecognitionAlternative_confidenceGetter(JSGlobalObject& lexicalGlobalObject, JSSpeechRecognitionAlternative& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLFloat>(lexicalGlobalObject, throwScope, impl.confidence())));
}

JSC_DEFINE_CUSTOM_GETTER(jsSpeechRecognitionAlternative_confidence, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSSpeechRecognitionAlternative>::get<jsSpeechRecognitionAlternative_confidenceGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "confidence");
}

JSC::IsoSubspace* JSSpeechRecognitionAlternative::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForSpeechRecognitionAlternative.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSSpeechRecognitionAlternative> || !JSSpeechRecognitionAlternative::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSSpeechRecognitionAlternative>)
        spaces.m_subspaceForSpeechRecognitionAlternative = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.destructibleObjectHeapCellType.get(), JSSpeechRecognitionAlternative);
    else
        spaces.m_subspaceForSpeechRecognitionAlternative = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.cellHeapCellType.get(), JSSpeechRecognitionAlternative);
    auto* space = spaces.m_subspaceForSpeechRecognitionAlternative.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    if (&JSSpeechRecognitionAlternative::visitOutputConstraints != &JSC::JSCell::visitOutputConstraints)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSSpeechRecognitionAlternative::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSSpeechRecognitionAlternative*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSSpeechRecognitionAlternativeOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSSpeechRecognitionAlternativeOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsSpeechRecognitionAlternative = static_cast<JSSpeechRecognitionAlternative*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsSpeechRecognitionAlternative->wrapped(), jsSpeechRecognitionAlternative);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<SpeechRecognitionAlternative>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to SpeechRecognitionAlternative.
    static_assert(!std::is_polymorphic<SpeechRecognitionAlternative>::value, "SpeechRecognitionAlternative is polymorphic but the IDL claims it is not");
    return createWrapper<SpeechRecognitionAlternative>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, SpeechRecognitionAlternative& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

SpeechRecognitionAlternative* JSSpeechRecognitionAlternative::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSSpeechRecognitionAlternative*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
