/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_AUDIO)

#include "JSWebKitAudioBufferSourceNode.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "JSAudioBuffer.h"
#include "JSAudioParam.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsWebKitAudioBufferSourceNodePrototypeFunction_start);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_buffer);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioBufferSourceNode_buffer);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_playbackState);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_gain);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_playbackRate);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_loop);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioBufferSourceNode_loop);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_loopStart);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioBufferSourceNode_loopStart);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_loopEnd);
static JSC_DECLARE_CUSTOM_SETTER(setJSWebKitAudioBufferSourceNode_loopEnd);

class JSWebKitAudioBufferSourceNodePrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebKitAudioBufferSourceNodePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebKitAudioBufferSourceNodePrototype* ptr = new (NotNull, JSC::allocateCell<JSWebKitAudioBufferSourceNodePrototype>(vm.heap)) JSWebKitAudioBufferSourceNodePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebKitAudioBufferSourceNodePrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebKitAudioBufferSourceNodePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebKitAudioBufferSourceNodePrototype, JSWebKitAudioBufferSourceNodePrototype::Base);

/* Hash table for prototype */

static const HashTableValue JSWebKitAudioBufferSourceNodePrototypeTableValues[] =
{
    { "buffer", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioBufferSourceNode_buffer), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioBufferSourceNode_buffer) } },
    { "playbackState", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioBufferSourceNode_playbackState), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "gain", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioBufferSourceNode_gain), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "playbackRate", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioBufferSourceNode_playbackRate), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "loop", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioBufferSourceNode_loop), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioBufferSourceNode_loop) } },
    { "loopStart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioBufferSourceNode_loopStart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioBufferSourceNode_loopStart) } },
    { "loopEnd", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitAudioBufferSourceNode_loopEnd), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebKitAudioBufferSourceNode_loopEnd) } },
    { "start", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebKitAudioBufferSourceNodePrototypeFunction_start), (intptr_t) (0) } },
    { "UNSCHEDULED_STATE", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(0) } },
    { "SCHEDULED_STATE", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(1) } },
    { "PLAYING_STATE", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(2) } },
    { "FINISHED_STATE", JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::ConstantInteger, NoIntrinsic, { (long long)(3) } },
};

const ClassInfo JSWebKitAudioBufferSourceNodePrototype::s_info = { "WebKitAudioBufferSourceNode", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebKitAudioBufferSourceNodePrototype) };

void JSWebKitAudioBufferSourceNodePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebKitAudioBufferSourceNode::info(), JSWebKitAudioBufferSourceNodePrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSWebKitAudioBufferSourceNode::s_info = { "WebKitAudioBufferSourceNode", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebKitAudioBufferSourceNode) };

JSWebKitAudioBufferSourceNode::JSWebKitAudioBufferSourceNode(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebKitAudioBufferSourceNode>&& impl)
    : JSAudioScheduledSourceNode(structure, globalObject, WTFMove(impl))
{
}

void JSWebKitAudioBufferSourceNode::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(std::is_base_of<ActiveDOMObject, WebKitAudioBufferSourceNode>::value, "Interface is marked as [ActiveDOMObject] but implementation class does not subclass ActiveDOMObject.");

}

JSObject* JSWebKitAudioBufferSourceNode::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSWebKitAudioBufferSourceNodePrototype::create(vm, &globalObject, JSWebKitAudioBufferSourceNodePrototype::createStructure(vm, &globalObject, JSAudioScheduledSourceNode::prototype(vm, globalObject)));
}

JSObject* JSWebKitAudioBufferSourceNode::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSWebKitAudioBufferSourceNode>(vm, globalObject);
}

template<> inline JSWebKitAudioBufferSourceNode* IDLAttribute<JSWebKitAudioBufferSourceNode>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSWebKitAudioBufferSourceNode*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

template<> inline JSWebKitAudioBufferSourceNode* IDLOperation<JSWebKitAudioBufferSourceNode>::cast(JSGlobalObject& lexicalGlobalObject, CallFrame& callFrame)
{
    return jsDynamicCast<JSWebKitAudioBufferSourceNode*>(JSC::getVM(&lexicalGlobalObject), callFrame.thisValue());
}

static inline JSValue jsWebKitAudioBufferSourceNode_bufferGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLNullable<IDLInterface<AudioBuffer>>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.buffer())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_buffer, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::get<jsWebKitAudioBufferSourceNode_bufferGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "buffer");
}

static inline bool setJSWebKitAudioBufferSourceNode_bufferSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLNullable<IDLInterface<AudioBuffer>>>(lexicalGlobalObject, value, [](JSC::JSGlobalObject& lexicalGlobalObject, JSC::ThrowScope& scope) { throwAttributeTypeError(lexicalGlobalObject, scope, "WebKitAudioBufferSourceNode", "buffer", "AudioBuffer"); });
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setBuffer(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioBufferSourceNode_buffer, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::set<setJSWebKitAudioBufferSourceNode_bufferSetter>(*lexicalGlobalObject, thisValue, encodedValue, "buffer");
}

static inline JSValue jsWebKitAudioBufferSourceNode_playbackStateGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnsignedShort>(lexicalGlobalObject, throwScope, impl.playbackState())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_playbackState, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::get<jsWebKitAudioBufferSourceNode_playbackStateGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "playbackState");
}

static inline JSValue jsWebKitAudioBufferSourceNode_gainGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.gain())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_gain, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::get<jsWebKitAudioBufferSourceNode_gainGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "gain");
}

static inline JSValue jsWebKitAudioBufferSourceNode_playbackRateGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.playbackRate())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_playbackRate, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::get<jsWebKitAudioBufferSourceNode_playbackRateGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "playbackRate");
}

static inline JSValue jsWebKitAudioBufferSourceNode_loopGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLBoolean>(lexicalGlobalObject, throwScope, impl.loop())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_loop, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::get<jsWebKitAudioBufferSourceNode_loopGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "loop");
}

static inline bool setJSWebKitAudioBufferSourceNode_loopSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLBoolean>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setLoop(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioBufferSourceNode_loop, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::set<setJSWebKitAudioBufferSourceNode_loopSetter>(*lexicalGlobalObject, thisValue, encodedValue, "loop");
}

static inline JSValue jsWebKitAudioBufferSourceNode_loopStartGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.loopStart())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_loopStart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::get<jsWebKitAudioBufferSourceNode_loopStartGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "loopStart");
}

static inline bool setJSWebKitAudioBufferSourceNode_loopStartSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setLoopStart(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioBufferSourceNode_loopStart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::set<setJSWebKitAudioBufferSourceNode_loopStartSetter>(*lexicalGlobalObject, thisValue, encodedValue, "loopStart");
}

static inline JSValue jsWebKitAudioBufferSourceNode_loopEndGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLDouble>(lexicalGlobalObject, throwScope, impl.loopEnd())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitAudioBufferSourceNode_loopEnd, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::get<jsWebKitAudioBufferSourceNode_loopEndGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "loopEnd");
}

static inline bool setJSWebKitAudioBufferSourceNode_loopEndSetter(JSGlobalObject& lexicalGlobalObject, JSWebKitAudioBufferSourceNode& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setLoopEnd(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSWebKitAudioBufferSourceNode_loopEnd, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSWebKitAudioBufferSourceNode>::set<setJSWebKitAudioBufferSourceNode_loopEndSetter>(*lexicalGlobalObject, thisValue, encodedValue, "loopEnd");
}

static inline JSC::EncodedJSValue jsWebKitAudioBufferSourceNodePrototypeFunction_startBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSWebKitAudioBufferSourceNode>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    EnsureStillAliveScope argument0 = callFrame->argument(0);
    auto when = argument0.value().isUndefined() ? 0 : convert<IDLDouble>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->argument(1);
    auto grainOffset = argument1.value().isUndefined() ? 0 : convert<IDLDouble>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->argument(2);
    auto grainDuration = argument2.value().isUndefined() ? Optional<Converter<IDLDouble>::ReturnType>() : Optional<Converter<IDLDouble>::ReturnType>(convert<IDLDouble>(*lexicalGlobalObject, argument2.value()));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    throwScope.release();
    propagateException(*lexicalGlobalObject, throwScope, impl.startLater(WTFMove(when), WTFMove(grainOffset), WTFMove(grainDuration)));
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsWebKitAudioBufferSourceNodePrototypeFunction_start, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSWebKitAudioBufferSourceNode>::call<jsWebKitAudioBufferSourceNodePrototypeFunction_startBody>(*lexicalGlobalObject, *callFrame, "start");
}

JSC::IsoSubspace* JSWebKitAudioBufferSourceNode::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForWebKitAudioBufferSourceNode.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSWebKitAudioBufferSourceNode> || !JSWebKitAudioBufferSourceNode::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSWebKitAudioBufferSourceNode>)
        spaces.m_subspaceForWebKitAudioBufferSourceNode = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.destructibleObjectHeapCellType.get(), JSWebKitAudioBufferSourceNode);
    else
        spaces.m_subspaceForWebKitAudioBufferSourceNode = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.cellHeapCellType.get(), JSWebKitAudioBufferSourceNode);
    auto* space = spaces.m_subspaceForWebKitAudioBufferSourceNode.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    if (&JSWebKitAudioBufferSourceNode::visitOutputConstraints != &JSC::JSCell::visitOutputConstraints)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSWebKitAudioBufferSourceNode::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSWebKitAudioBufferSourceNode*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSWebKitAudioBufferSourceNodeOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    auto* jsWebKitAudioBufferSourceNode = jsCast<JSWebKitAudioBufferSourceNode*>(handle.slot()->asCell());
    auto& wrapped = jsWebKitAudioBufferSourceNode->wrapped();
    if (!wrapped.isContextStopped() && wrapped.hasPendingActivity()) {
        if (UNLIKELY(reason))
            *reason = "ActiveDOMObject with pending activity";
        return true;
     }
    if (jsWebKitAudioBufferSourceNode->wrapped().isFiringEventListeners()) {
        if (UNLIKELY(reason))
            *reason = "EventTarget firing event listeners";
        return true;
    }
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSWebKitAudioBufferSourceNodeOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsWebKitAudioBufferSourceNode = static_cast<JSWebKitAudioBufferSourceNode*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsWebKitAudioBufferSourceNode->wrapped(), jsWebKitAudioBufferSourceNode);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7WebKitAudioBufferSourceNode@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore27WebKitAudioBufferSourceNodeE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<WebKitAudioBufferSourceNode>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    const void* actualVTablePointer = getVTablePointer(impl.ptr());
#if PLATFORM(WIN)
    void* expectedVTablePointer = __identifier("??_7WebKitAudioBufferSourceNode@WebCore@@6B@");
#else
    void* expectedVTablePointer = &_ZTVN7WebCore27WebKitAudioBufferSourceNodeE[2];
#endif

    // If this fails WebKitAudioBufferSourceNode does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<WebKitAudioBufferSourceNode>::value, "WebKitAudioBufferSourceNode is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // WebKitAudioBufferSourceNode has subclasses. If WebKitAudioBufferSourceNode has subclasses that get passed
    // to toJS() we currently require WebKitAudioBufferSourceNode you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<WebKitAudioBufferSourceNode>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WebKitAudioBufferSourceNode& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}


}

#endif // ENABLE(WEB_AUDIO)
