/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_AUDIO)

#include "JSWebKitDynamicsCompressorNode.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "JSAudioParam.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_threshold);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_knee);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_ratio);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_attack);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_release);
static JSC_DECLARE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_reduction);

class JSWebKitDynamicsCompressorNodePrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebKitDynamicsCompressorNodePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebKitDynamicsCompressorNodePrototype* ptr = new (NotNull, JSC::allocateCell<JSWebKitDynamicsCompressorNodePrototype>(vm.heap)) JSWebKitDynamicsCompressorNodePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebKitDynamicsCompressorNodePrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebKitDynamicsCompressorNodePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebKitDynamicsCompressorNodePrototype, JSWebKitDynamicsCompressorNodePrototype::Base);

/* Hash table for prototype */

static const HashTableValue JSWebKitDynamicsCompressorNodePrototypeTableValues[] =
{
    { "threshold", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitDynamicsCompressorNode_threshold), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "knee", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitDynamicsCompressorNode_knee), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "ratio", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitDynamicsCompressorNode_ratio), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "attack", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitDynamicsCompressorNode_attack), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "release", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitDynamicsCompressorNode_release), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "reduction", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebKitDynamicsCompressorNode_reduction), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSWebKitDynamicsCompressorNodePrototype::s_info = { "WebKitDynamicsCompressorNode", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebKitDynamicsCompressorNodePrototype) };

void JSWebKitDynamicsCompressorNodePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebKitDynamicsCompressorNode::info(), JSWebKitDynamicsCompressorNodePrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSWebKitDynamicsCompressorNode::s_info = { "WebKitDynamicsCompressorNode", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebKitDynamicsCompressorNode) };

JSWebKitDynamicsCompressorNode::JSWebKitDynamicsCompressorNode(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebKitDynamicsCompressorNode>&& impl)
    : JSAudioNode(structure, globalObject, WTFMove(impl))
{
}

void JSWebKitDynamicsCompressorNode::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, WebKitDynamicsCompressorNode>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSWebKitDynamicsCompressorNode::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSWebKitDynamicsCompressorNodePrototype::create(vm, &globalObject, JSWebKitDynamicsCompressorNodePrototype::createStructure(vm, &globalObject, JSAudioNode::prototype(vm, globalObject)));
}

JSObject* JSWebKitDynamicsCompressorNode::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSWebKitDynamicsCompressorNode>(vm, globalObject);
}

template<> inline JSWebKitDynamicsCompressorNode* IDLAttribute<JSWebKitDynamicsCompressorNode>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSWebKitDynamicsCompressorNode*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

static inline JSValue jsWebKitDynamicsCompressorNode_thresholdGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitDynamicsCompressorNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.threshold())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_threshold, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitDynamicsCompressorNode>::get<jsWebKitDynamicsCompressorNode_thresholdGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "threshold");
}

static inline JSValue jsWebKitDynamicsCompressorNode_kneeGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitDynamicsCompressorNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.knee())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_knee, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitDynamicsCompressorNode>::get<jsWebKitDynamicsCompressorNode_kneeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "knee");
}

static inline JSValue jsWebKitDynamicsCompressorNode_ratioGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitDynamicsCompressorNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.ratio())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_ratio, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitDynamicsCompressorNode>::get<jsWebKitDynamicsCompressorNode_ratioGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ratio");
}

static inline JSValue jsWebKitDynamicsCompressorNode_attackGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitDynamicsCompressorNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.attack())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_attack, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitDynamicsCompressorNode>::get<jsWebKitDynamicsCompressorNode_attackGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "attack");
}

static inline JSValue jsWebKitDynamicsCompressorNode_releaseGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitDynamicsCompressorNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.release())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_release, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitDynamicsCompressorNode>::get<jsWebKitDynamicsCompressorNode_releaseGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "release");
}

static inline JSValue jsWebKitDynamicsCompressorNode_reductionGetter(JSGlobalObject& lexicalGlobalObject, JSWebKitDynamicsCompressorNode& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<AudioParam>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.legacyReduction())));
}

JSC_DEFINE_CUSTOM_GETTER(jsWebKitDynamicsCompressorNode_reduction, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSWebKitDynamicsCompressorNode>::get<jsWebKitDynamicsCompressorNode_reductionGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "reduction");
}

JSC::IsoSubspace* JSWebKitDynamicsCompressorNode::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForWebKitDynamicsCompressorNode.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSWebKitDynamicsCompressorNode> || !JSWebKitDynamicsCompressorNode::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSWebKitDynamicsCompressorNode>)
        spaces.m_subspaceForWebKitDynamicsCompressorNode = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.destructibleObjectHeapCellType.get(), JSWebKitDynamicsCompressorNode);
    else
        spaces.m_subspaceForWebKitDynamicsCompressorNode = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.cellHeapCellType.get(), JSWebKitDynamicsCompressorNode);
    auto* space = spaces.m_subspaceForWebKitDynamicsCompressorNode.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    if (&JSWebKitDynamicsCompressorNode::visitOutputConstraints != &JSC::JSCell::visitOutputConstraints)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSWebKitDynamicsCompressorNode::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSWebKitDynamicsCompressorNode*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7WebKitDynamicsCompressorNode@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore28WebKitDynamicsCompressorNodeE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<WebKitDynamicsCompressorNode>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    const void* actualVTablePointer = getVTablePointer(impl.ptr());
#if PLATFORM(WIN)
    void* expectedVTablePointer = __identifier("??_7WebKitDynamicsCompressorNode@WebCore@@6B@");
#else
    void* expectedVTablePointer = &_ZTVN7WebCore28WebKitDynamicsCompressorNodeE[2];
#endif

    // If this fails WebKitDynamicsCompressorNode does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<WebKitDynamicsCompressorNode>::value, "WebKitDynamicsCompressorNode is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // WebKitDynamicsCompressorNode has subclasses. If WebKitDynamicsCompressorNode has subclasses that get passed
    // to toJS() we currently require WebKitDynamicsCompressorNode you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<WebKitDynamicsCompressorNode>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WebKitDynamicsCompressorNode& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}


}

#endif // ENABLE(WEB_AUDIO)
